//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2019 SeMI Holding B.V. (registered @ Dutch Chamber of Commerce no 75221632). All rights reserved.
//  LICENSE WEAVIATE OPEN SOURCE: https://www.semi.technology/playbook/playbook/contract-weaviate-OSS.html
//  LICENSE WEAVIATE ENTERPRISE: https://www.semi.technology/playbook/contract-weaviate-enterprise.html
//  CONCEPT: Bob van Luijt (@bobvanluijt)
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package batching

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	models "github.com/semi-technologies/weaviate/entities/models"
)

// BatchingActionsCreateOKCode is the HTTP code returned for type BatchingActionsCreateOK
const BatchingActionsCreateOKCode int = 200

/*BatchingActionsCreateOK Request succeeded, see response body to get detailed information about each batched item.

swagger:response batchingActionsCreateOK
*/
type BatchingActionsCreateOK struct {

	/*
	  In: Body
	*/
	Payload []*models.ActionsGetResponse `json:"body,omitempty"`
}

// NewBatchingActionsCreateOK creates BatchingActionsCreateOK with default headers values
func NewBatchingActionsCreateOK() *BatchingActionsCreateOK {

	return &BatchingActionsCreateOK{}
}

// WithPayload adds the payload to the batching actions create o k response
func (o *BatchingActionsCreateOK) WithPayload(payload []*models.ActionsGetResponse) *BatchingActionsCreateOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the batching actions create o k response
func (o *BatchingActionsCreateOK) SetPayload(payload []*models.ActionsGetResponse) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *BatchingActionsCreateOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	payload := o.Payload
	if payload == nil {
		// return empty array
		payload = make([]*models.ActionsGetResponse, 0, 50)
	}

	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}
}

// BatchingActionsCreateUnauthorizedCode is the HTTP code returned for type BatchingActionsCreateUnauthorized
const BatchingActionsCreateUnauthorizedCode int = 401

/*BatchingActionsCreateUnauthorized Unauthorized or invalid credentials.

swagger:response batchingActionsCreateUnauthorized
*/
type BatchingActionsCreateUnauthorized struct {
}

// NewBatchingActionsCreateUnauthorized creates BatchingActionsCreateUnauthorized with default headers values
func NewBatchingActionsCreateUnauthorized() *BatchingActionsCreateUnauthorized {

	return &BatchingActionsCreateUnauthorized{}
}

// WriteResponse to the client
func (o *BatchingActionsCreateUnauthorized) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(401)
}

// BatchingActionsCreateForbiddenCode is the HTTP code returned for type BatchingActionsCreateForbidden
const BatchingActionsCreateForbiddenCode int = 403

/*BatchingActionsCreateForbidden Forbidden

swagger:response batchingActionsCreateForbidden
*/
type BatchingActionsCreateForbidden struct {

	/*
	  In: Body
	*/
	Payload *models.ErrorResponse `json:"body,omitempty"`
}

// NewBatchingActionsCreateForbidden creates BatchingActionsCreateForbidden with default headers values
func NewBatchingActionsCreateForbidden() *BatchingActionsCreateForbidden {

	return &BatchingActionsCreateForbidden{}
}

// WithPayload adds the payload to the batching actions create forbidden response
func (o *BatchingActionsCreateForbidden) WithPayload(payload *models.ErrorResponse) *BatchingActionsCreateForbidden {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the batching actions create forbidden response
func (o *BatchingActionsCreateForbidden) SetPayload(payload *models.ErrorResponse) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *BatchingActionsCreateForbidden) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(403)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// BatchingActionsCreateUnprocessableEntityCode is the HTTP code returned for type BatchingActionsCreateUnprocessableEntity
const BatchingActionsCreateUnprocessableEntityCode int = 422

/*BatchingActionsCreateUnprocessableEntity Request body is well-formed (i.e., syntactically correct), but semantically erroneous. Are you sure the class is defined in the configuration file?

swagger:response batchingActionsCreateUnprocessableEntity
*/
type BatchingActionsCreateUnprocessableEntity struct {

	/*
	  In: Body
	*/
	Payload *models.ErrorResponse `json:"body,omitempty"`
}

// NewBatchingActionsCreateUnprocessableEntity creates BatchingActionsCreateUnprocessableEntity with default headers values
func NewBatchingActionsCreateUnprocessableEntity() *BatchingActionsCreateUnprocessableEntity {

	return &BatchingActionsCreateUnprocessableEntity{}
}

// WithPayload adds the payload to the batching actions create unprocessable entity response
func (o *BatchingActionsCreateUnprocessableEntity) WithPayload(payload *models.ErrorResponse) *BatchingActionsCreateUnprocessableEntity {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the batching actions create unprocessable entity response
func (o *BatchingActionsCreateUnprocessableEntity) SetPayload(payload *models.ErrorResponse) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *BatchingActionsCreateUnprocessableEntity) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(422)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// BatchingActionsCreateInternalServerErrorCode is the HTTP code returned for type BatchingActionsCreateInternalServerError
const BatchingActionsCreateInternalServerErrorCode int = 500

/*BatchingActionsCreateInternalServerError An error has occurred while trying to fulfill the request. Most likely the ErrorResponse will contain more information about the error.

swagger:response batchingActionsCreateInternalServerError
*/
type BatchingActionsCreateInternalServerError struct {

	/*
	  In: Body
	*/
	Payload *models.ErrorResponse `json:"body,omitempty"`
}

// NewBatchingActionsCreateInternalServerError creates BatchingActionsCreateInternalServerError with default headers values
func NewBatchingActionsCreateInternalServerError() *BatchingActionsCreateInternalServerError {

	return &BatchingActionsCreateInternalServerError{}
}

// WithPayload adds the payload to the batching actions create internal server error response
func (o *BatchingActionsCreateInternalServerError) WithPayload(payload *models.ErrorResponse) *BatchingActionsCreateInternalServerError {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the batching actions create internal server error response
func (o *BatchingActionsCreateInternalServerError) SetPayload(payload *models.ErrorResponse) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *BatchingActionsCreateInternalServerError) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(500)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
