//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2019 SeMI Holding B.V. (registered @ Dutch Chamber of Commerce no 75221632). All rights reserved.
//  LICENSE WEAVIATE OPEN SOURCE: https://www.semi.technology/playbook/playbook/contract-weaviate-OSS.html
//  LICENSE WEAVIATE ENTERPRISE: https://www.semi.technology/playbook/contract-weaviate-enterprise.html
//  CONCEPT: Bob van Luijt (@bobvanluijt)
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package contextionary_api

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	middleware "github.com/go-openapi/runtime/middleware"

	models "github.com/semi-technologies/weaviate/entities/models"
)

// C11yWordsHandlerFunc turns a function with the right signature into a c11y words handler
type C11yWordsHandlerFunc func(C11yWordsParams, *models.Principal) middleware.Responder

// Handle executing the request and returning a response
func (fn C11yWordsHandlerFunc) Handle(params C11yWordsParams, principal *models.Principal) middleware.Responder {
	return fn(params, principal)
}

// C11yWordsHandler interface for that can handle valid c11y words params
type C11yWordsHandler interface {
	Handle(C11yWordsParams, *models.Principal) middleware.Responder
}

// NewC11yWords creates a new http.Handler for the c11y words operation
func NewC11yWords(ctx *middleware.Context, handler C11yWordsHandler) *C11yWords {
	return &C11yWords{Context: ctx, Handler: handler}
}

/*C11yWords swagger:route GET /c11y/words/{words} contextionary-API c11yWords

Checks if a word or wordString is part of the contextionary.

Checks if a word or wordString is part of the contextionary. Words should be concatenated as described here: https://github.com/semi-technologies/weaviate/blob/master/docs/en/use/ontology-schema.md#camelcase

*/
type C11yWords struct {
	Context *middleware.Context
	Handler C11yWordsHandler
}

func (o *C11yWords) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewC11yWordsParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal *models.Principal
	if uprinc != nil {
		principal = uprinc.(*models.Principal) // this is really a models.Principal, I promise
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
