//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2019 SeMI Holding B.V. (registered @ Dutch Chamber of Commerce no 75221632). All rights reserved.
//  LICENSE WEAVIATE OPEN SOURCE: https://www.semi.technology/playbook/playbook/contract-weaviate-OSS.html
//  LICENSE WEAVIATE ENTERPRISE: https://www.semi.technology/playbook/contract-weaviate-enterprise.html
//  CONCEPT: Bob van Luijt (@bobvanluijt)
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package schema

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	models "github.com/semi-technologies/weaviate/entities/models"
)

// SchemaActionsPropertiesDeleteOKCode is the HTTP code returned for type SchemaActionsPropertiesDeleteOK
const SchemaActionsPropertiesDeleteOKCode int = 200

/*SchemaActionsPropertiesDeleteOK Removed the property from the ontology.

swagger:response schemaActionsPropertiesDeleteOK
*/
type SchemaActionsPropertiesDeleteOK struct {
}

// NewSchemaActionsPropertiesDeleteOK creates SchemaActionsPropertiesDeleteOK with default headers values
func NewSchemaActionsPropertiesDeleteOK() *SchemaActionsPropertiesDeleteOK {

	return &SchemaActionsPropertiesDeleteOK{}
}

// WriteResponse to the client
func (o *SchemaActionsPropertiesDeleteOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(200)
}

// SchemaActionsPropertiesDeleteUnauthorizedCode is the HTTP code returned for type SchemaActionsPropertiesDeleteUnauthorized
const SchemaActionsPropertiesDeleteUnauthorizedCode int = 401

/*SchemaActionsPropertiesDeleteUnauthorized Unauthorized or invalid credentials.

swagger:response schemaActionsPropertiesDeleteUnauthorized
*/
type SchemaActionsPropertiesDeleteUnauthorized struct {
}

// NewSchemaActionsPropertiesDeleteUnauthorized creates SchemaActionsPropertiesDeleteUnauthorized with default headers values
func NewSchemaActionsPropertiesDeleteUnauthorized() *SchemaActionsPropertiesDeleteUnauthorized {

	return &SchemaActionsPropertiesDeleteUnauthorized{}
}

// WriteResponse to the client
func (o *SchemaActionsPropertiesDeleteUnauthorized) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(401)
}

// SchemaActionsPropertiesDeleteForbiddenCode is the HTTP code returned for type SchemaActionsPropertiesDeleteForbidden
const SchemaActionsPropertiesDeleteForbiddenCode int = 403

/*SchemaActionsPropertiesDeleteForbidden Forbidden

swagger:response schemaActionsPropertiesDeleteForbidden
*/
type SchemaActionsPropertiesDeleteForbidden struct {

	/*
	  In: Body
	*/
	Payload *models.ErrorResponse `json:"body,omitempty"`
}

// NewSchemaActionsPropertiesDeleteForbidden creates SchemaActionsPropertiesDeleteForbidden with default headers values
func NewSchemaActionsPropertiesDeleteForbidden() *SchemaActionsPropertiesDeleteForbidden {

	return &SchemaActionsPropertiesDeleteForbidden{}
}

// WithPayload adds the payload to the schema actions properties delete forbidden response
func (o *SchemaActionsPropertiesDeleteForbidden) WithPayload(payload *models.ErrorResponse) *SchemaActionsPropertiesDeleteForbidden {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the schema actions properties delete forbidden response
func (o *SchemaActionsPropertiesDeleteForbidden) SetPayload(payload *models.ErrorResponse) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *SchemaActionsPropertiesDeleteForbidden) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(403)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// SchemaActionsPropertiesDeleteInternalServerErrorCode is the HTTP code returned for type SchemaActionsPropertiesDeleteInternalServerError
const SchemaActionsPropertiesDeleteInternalServerErrorCode int = 500

/*SchemaActionsPropertiesDeleteInternalServerError An error has occurred while trying to fulfill the request. Most likely the ErrorResponse will contain more information about the error.

swagger:response schemaActionsPropertiesDeleteInternalServerError
*/
type SchemaActionsPropertiesDeleteInternalServerError struct {

	/*
	  In: Body
	*/
	Payload *models.ErrorResponse `json:"body,omitempty"`
}

// NewSchemaActionsPropertiesDeleteInternalServerError creates SchemaActionsPropertiesDeleteInternalServerError with default headers values
func NewSchemaActionsPropertiesDeleteInternalServerError() *SchemaActionsPropertiesDeleteInternalServerError {

	return &SchemaActionsPropertiesDeleteInternalServerError{}
}

// WithPayload adds the payload to the schema actions properties delete internal server error response
func (o *SchemaActionsPropertiesDeleteInternalServerError) WithPayload(payload *models.ErrorResponse) *SchemaActionsPropertiesDeleteInternalServerError {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the schema actions properties delete internal server error response
func (o *SchemaActionsPropertiesDeleteInternalServerError) SetPayload(payload *models.ErrorResponse) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *SchemaActionsPropertiesDeleteInternalServerError) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(500)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
