//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2019 SeMI Holding B.V. (registered @ Dutch Chamber of Commerce no 75221632). All rights reserved.
//  LICENSE WEAVIATE OPEN SOURCE: https://www.semi.technology/playbook/playbook/contract-weaviate-OSS.html
//  LICENSE WEAVIATE ENTERPRISE: https://www.semi.technology/playbook/contract-weaviate-enterprise.html
//  CONCEPT: Bob van Luijt (@bobvanluijt)
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package actions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	models "github.com/semi-technologies/weaviate/entities/models"
)

// ActionsDeleteReader is a Reader for the ActionsDelete structure.
type ActionsDeleteReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *ActionsDeleteReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 204:
		result := NewActionsDeleteNoContent()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewActionsDeleteUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewActionsDeleteForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewActionsDeleteNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewActionsDeleteInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewActionsDeleteNoContent creates a ActionsDeleteNoContent with default headers values
func NewActionsDeleteNoContent() *ActionsDeleteNoContent {
	return &ActionsDeleteNoContent{}
}

/*ActionsDeleteNoContent handles this case with default header values.

Successfully deleted.
*/
type ActionsDeleteNoContent struct {
}

func (o *ActionsDeleteNoContent) Error() string {
	return fmt.Sprintf("[DELETE /actions/{id}][%d] actionsDeleteNoContent ", 204)
}

func (o *ActionsDeleteNoContent) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewActionsDeleteUnauthorized creates a ActionsDeleteUnauthorized with default headers values
func NewActionsDeleteUnauthorized() *ActionsDeleteUnauthorized {
	return &ActionsDeleteUnauthorized{}
}

/*ActionsDeleteUnauthorized handles this case with default header values.

Unauthorized or invalid credentials.
*/
type ActionsDeleteUnauthorized struct {
}

func (o *ActionsDeleteUnauthorized) Error() string {
	return fmt.Sprintf("[DELETE /actions/{id}][%d] actionsDeleteUnauthorized ", 401)
}

func (o *ActionsDeleteUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewActionsDeleteForbidden creates a ActionsDeleteForbidden with default headers values
func NewActionsDeleteForbidden() *ActionsDeleteForbidden {
	return &ActionsDeleteForbidden{}
}

/*ActionsDeleteForbidden handles this case with default header values.

Forbidden
*/
type ActionsDeleteForbidden struct {
	Payload *models.ErrorResponse
}

func (o *ActionsDeleteForbidden) Error() string {
	return fmt.Sprintf("[DELETE /actions/{id}][%d] actionsDeleteForbidden  %+v", 403, o.Payload)
}

func (o *ActionsDeleteForbidden) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *ActionsDeleteForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewActionsDeleteNotFound creates a ActionsDeleteNotFound with default headers values
func NewActionsDeleteNotFound() *ActionsDeleteNotFound {
	return &ActionsDeleteNotFound{}
}

/*ActionsDeleteNotFound handles this case with default header values.

Successful query result but no resource was found.
*/
type ActionsDeleteNotFound struct {
}

func (o *ActionsDeleteNotFound) Error() string {
	return fmt.Sprintf("[DELETE /actions/{id}][%d] actionsDeleteNotFound ", 404)
}

func (o *ActionsDeleteNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewActionsDeleteInternalServerError creates a ActionsDeleteInternalServerError with default headers values
func NewActionsDeleteInternalServerError() *ActionsDeleteInternalServerError {
	return &ActionsDeleteInternalServerError{}
}

/*ActionsDeleteInternalServerError handles this case with default header values.

An error has occurred while trying to fulfill the request. Most likely the ErrorResponse will contain more information about the error.
*/
type ActionsDeleteInternalServerError struct {
	Payload *models.ErrorResponse
}

func (o *ActionsDeleteInternalServerError) Error() string {
	return fmt.Sprintf("[DELETE /actions/{id}][%d] actionsDeleteInternalServerError  %+v", 500, o.Payload)
}

func (o *ActionsDeleteInternalServerError) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *ActionsDeleteInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
