//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2019 SeMI Holding B.V. (registered @ Dutch Chamber of Commerce no 75221632). All rights reserved.
//  LICENSE WEAVIATE OPEN SOURCE: https://www.semi.technology/playbook/playbook/contract-weaviate-OSS.html
//  LICENSE WEAVIATE ENTERPRISE: https://www.semi.technology/playbook/contract-weaviate-enterprise.html
//  CONCEPT: Bob van Luijt (@bobvanluijt)
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package schema

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	models "github.com/semi-technologies/weaviate/entities/models"
)

// SchemaActionsDeleteReader is a Reader for the SchemaActionsDelete structure.
type SchemaActionsDeleteReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *SchemaActionsDeleteReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewSchemaActionsDeleteOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewSchemaActionsDeleteBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 401:
		result := NewSchemaActionsDeleteUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewSchemaActionsDeleteForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewSchemaActionsDeleteInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewSchemaActionsDeleteOK creates a SchemaActionsDeleteOK with default headers values
func NewSchemaActionsDeleteOK() *SchemaActionsDeleteOK {
	return &SchemaActionsDeleteOK{}
}

/*SchemaActionsDeleteOK handles this case with default header values.

Removed the Action class from the ontology.
*/
type SchemaActionsDeleteOK struct {
}

func (o *SchemaActionsDeleteOK) Error() string {
	return fmt.Sprintf("[DELETE /schema/actions/{className}][%d] schemaActionsDeleteOK ", 200)
}

func (o *SchemaActionsDeleteOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewSchemaActionsDeleteBadRequest creates a SchemaActionsDeleteBadRequest with default headers values
func NewSchemaActionsDeleteBadRequest() *SchemaActionsDeleteBadRequest {
	return &SchemaActionsDeleteBadRequest{}
}

/*SchemaActionsDeleteBadRequest handles this case with default header values.

Could not delete the Action class.
*/
type SchemaActionsDeleteBadRequest struct {
	Payload *models.ErrorResponse
}

func (o *SchemaActionsDeleteBadRequest) Error() string {
	return fmt.Sprintf("[DELETE /schema/actions/{className}][%d] schemaActionsDeleteBadRequest  %+v", 400, o.Payload)
}

func (o *SchemaActionsDeleteBadRequest) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *SchemaActionsDeleteBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewSchemaActionsDeleteUnauthorized creates a SchemaActionsDeleteUnauthorized with default headers values
func NewSchemaActionsDeleteUnauthorized() *SchemaActionsDeleteUnauthorized {
	return &SchemaActionsDeleteUnauthorized{}
}

/*SchemaActionsDeleteUnauthorized handles this case with default header values.

Unauthorized or invalid credentials.
*/
type SchemaActionsDeleteUnauthorized struct {
}

func (o *SchemaActionsDeleteUnauthorized) Error() string {
	return fmt.Sprintf("[DELETE /schema/actions/{className}][%d] schemaActionsDeleteUnauthorized ", 401)
}

func (o *SchemaActionsDeleteUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewSchemaActionsDeleteForbidden creates a SchemaActionsDeleteForbidden with default headers values
func NewSchemaActionsDeleteForbidden() *SchemaActionsDeleteForbidden {
	return &SchemaActionsDeleteForbidden{}
}

/*SchemaActionsDeleteForbidden handles this case with default header values.

Forbidden
*/
type SchemaActionsDeleteForbidden struct {
	Payload *models.ErrorResponse
}

func (o *SchemaActionsDeleteForbidden) Error() string {
	return fmt.Sprintf("[DELETE /schema/actions/{className}][%d] schemaActionsDeleteForbidden  %+v", 403, o.Payload)
}

func (o *SchemaActionsDeleteForbidden) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *SchemaActionsDeleteForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewSchemaActionsDeleteInternalServerError creates a SchemaActionsDeleteInternalServerError with default headers values
func NewSchemaActionsDeleteInternalServerError() *SchemaActionsDeleteInternalServerError {
	return &SchemaActionsDeleteInternalServerError{}
}

/*SchemaActionsDeleteInternalServerError handles this case with default header values.

An error has occurred while trying to fulfill the request. Most likely the ErrorResponse will contain more information about the error.
*/
type SchemaActionsDeleteInternalServerError struct {
	Payload *models.ErrorResponse
}

func (o *SchemaActionsDeleteInternalServerError) Error() string {
	return fmt.Sprintf("[DELETE /schema/actions/{className}][%d] schemaActionsDeleteInternalServerError  %+v", 500, o.Payload)
}

func (o *SchemaActionsDeleteInternalServerError) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *SchemaActionsDeleteInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
