//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2019 SeMI Holding B.V. (registered @ Dutch Chamber of Commerce no 75221632). All rights reserved.
//  LICENSE WEAVIATE OPEN SOURCE: https://www.semi.technology/playbook/playbook/contract-weaviate-OSS.html
//  LICENSE WEAVIATE ENTERPRISE: https://www.semi.technology/playbook/contract-weaviate-enterprise.html
//  CONCEPT: Bob van Luijt (@bobvanluijt)
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package schema

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	models "github.com/semi-technologies/weaviate/entities/models"
)

// SchemaThingsCreateReader is a Reader for the SchemaThingsCreate structure.
type SchemaThingsCreateReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *SchemaThingsCreateReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewSchemaThingsCreateOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewSchemaThingsCreateUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewSchemaThingsCreateForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewSchemaThingsCreateUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewSchemaThingsCreateInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewSchemaThingsCreateOK creates a SchemaThingsCreateOK with default headers values
func NewSchemaThingsCreateOK() *SchemaThingsCreateOK {
	return &SchemaThingsCreateOK{}
}

/*SchemaThingsCreateOK handles this case with default header values.

Added the new Thing class to the ontology.
*/
type SchemaThingsCreateOK struct {
	Payload *models.Class
}

func (o *SchemaThingsCreateOK) Error() string {
	return fmt.Sprintf("[POST /schema/things][%d] schemaThingsCreateOK  %+v", 200, o.Payload)
}

func (o *SchemaThingsCreateOK) GetPayload() *models.Class {
	return o.Payload
}

func (o *SchemaThingsCreateOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Class)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewSchemaThingsCreateUnauthorized creates a SchemaThingsCreateUnauthorized with default headers values
func NewSchemaThingsCreateUnauthorized() *SchemaThingsCreateUnauthorized {
	return &SchemaThingsCreateUnauthorized{}
}

/*SchemaThingsCreateUnauthorized handles this case with default header values.

Unauthorized or invalid credentials.
*/
type SchemaThingsCreateUnauthorized struct {
}

func (o *SchemaThingsCreateUnauthorized) Error() string {
	return fmt.Sprintf("[POST /schema/things][%d] schemaThingsCreateUnauthorized ", 401)
}

func (o *SchemaThingsCreateUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewSchemaThingsCreateForbidden creates a SchemaThingsCreateForbidden with default headers values
func NewSchemaThingsCreateForbidden() *SchemaThingsCreateForbidden {
	return &SchemaThingsCreateForbidden{}
}

/*SchemaThingsCreateForbidden handles this case with default header values.

Forbidden
*/
type SchemaThingsCreateForbidden struct {
	Payload *models.ErrorResponse
}

func (o *SchemaThingsCreateForbidden) Error() string {
	return fmt.Sprintf("[POST /schema/things][%d] schemaThingsCreateForbidden  %+v", 403, o.Payload)
}

func (o *SchemaThingsCreateForbidden) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *SchemaThingsCreateForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewSchemaThingsCreateUnprocessableEntity creates a SchemaThingsCreateUnprocessableEntity with default headers values
func NewSchemaThingsCreateUnprocessableEntity() *SchemaThingsCreateUnprocessableEntity {
	return &SchemaThingsCreateUnprocessableEntity{}
}

/*SchemaThingsCreateUnprocessableEntity handles this case with default header values.

Invalid Thing class.
*/
type SchemaThingsCreateUnprocessableEntity struct {
	Payload *models.ErrorResponse
}

func (o *SchemaThingsCreateUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /schema/things][%d] schemaThingsCreateUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *SchemaThingsCreateUnprocessableEntity) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *SchemaThingsCreateUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewSchemaThingsCreateInternalServerError creates a SchemaThingsCreateInternalServerError with default headers values
func NewSchemaThingsCreateInternalServerError() *SchemaThingsCreateInternalServerError {
	return &SchemaThingsCreateInternalServerError{}
}

/*SchemaThingsCreateInternalServerError handles this case with default header values.

An error has occurred while trying to fulfill the request. Most likely the ErrorResponse will contain more information about the error.
*/
type SchemaThingsCreateInternalServerError struct {
	Payload *models.ErrorResponse
}

func (o *SchemaThingsCreateInternalServerError) Error() string {
	return fmt.Sprintf("[POST /schema/things][%d] schemaThingsCreateInternalServerError  %+v", 500, o.Payload)
}

func (o *SchemaThingsCreateInternalServerError) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *SchemaThingsCreateInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
